## ----include = FALSE----------------------------------------------------------
doBasics = TRUE
doAll = FALSE
doNot = FALSE


## ----eval=doNot---------------------------------------------------------------
## setwd("../TCGA_CRC")
## indir = getwd()
## files = list.files(indir, pattern='\\counts.gz')
## Metadata = read.csv(file= "ALL_data_TCGA_colonyrectum.csv",
##                     header = TRUE, sep=",")
## TCGA_CRC_Data = readDGE(files, path=indir, columns=c(1,2),
##                         group=Metadata$Sample_Type)
## save(TCGA_CRC, file = "TCGA_CRC.rda")


## ----eval=doNot---------------------------------------------------------------
## setwd("/home4/BAM_STAR/") ##Where the files can be found
## x = read.csv("files.txt",stringsAsFactors = FALSE)
## foutput = "lanza_STAR"
## file.create(foutput)
## dir_aligned = "/home4/BAM_STAR/"
## for(i in 1:nrow(x)){
##   file_sam = paste0(dir_aligned,x[i,1])
##   file_bam = paste0(dir_aligned,x[i,1],".bam")
##   chunk3 = paste("samtools view -bS ",file_sam,
##                  " | samtools sort - ",file_bam,"\n")
##   cat(chunk3,file=foutput,append = TRUE)
## }


## ----eval=doNot---------------------------------------------------------------
## library(Rsamtools)
## library(GenomicFeatures)
## library(GenomicAlignments)
## gtfFile = "/home4/Data_SRA/GRCh38.gtf"
## txdb = makeTxDbFromGFF(gtfFile, format="gtf")
## genes = exonsBy(txdb, by="gene")
## dirActualData =  paste(getwd(),"/",sep="")
## sampleTable = read.table("file.txt")
## fls = paste(dirActualData,sampleTable[,1],sep="")
## bamLst = BamFileList(fls, index=character(),
##                      yieldSize=100000,obeyQname=TRUE)
## PRJNA218851_CRC =
##   summarizeOverlaps(features = genes,read=bamLst,
##                     mode="Union",
##                     singleEnd=FALSE,
##                     ignore.strand=TRUE,
##                     fragments=FALSE)
## Metadata = read.csv(file= "PRJNA218851_CRC.csv",
##                     header = TRUE, sep=",")
## SampleName = Metadata$name_file
## Stage = Metadata$Stage
## colData(PRJNA218851_CRC) = DataFrame(SampleName, Stage)
## save(PRJNA218851_CRC,file="PRJNA218851_CRC.rda")


## ----eval = doNot-------------------------------------------------------------
## pacman::p_load(SummarizedExperiment,edgeR)
## load("PRJNA218851_CRC.rda")
## dim(PRJNA218851_CRC)
## colData(PRJNA218851_CRC)[,"Stage"]
## x1 = PRJNA218851_CRC[,1:36]
## dim(x1)
## colnames_x1 = colnames(assay(x1))
## colData(x1)[,"Stage"] = factor(colData(x1)[,"Stage"])
## levels(colData(x1)[,"Stage"]) = c("case","control")
## colData(x1) = DataFrame(tissue = colData(x1)[,"Stage"],
##                         pair = c(51:68,51:68))
## levels(colData(x1)[,"tissue"])
## load("TCGA_CRC.rda")
## dim(TCGA_CRC)
## meta = read.csv("metadata.csv",header=TRUE,sep=";")
## levels(meta$Group) = c("control","case")
## match(TCGA_CRC$samples$files,meta[,"File_name"])
## x2 = SummarizedExperiment(assays=TCGA_CRC$counts,
##                           rowData=rownames(TCGA_CRC$counts))
## colData(x2) = DataFrame(tissue=meta$Group,pair = meta$pair)
## x2 = x2[1:60482]
## dim(x2)
## rowData(x2) = unlist(lapply(rowData(x2)$X,function(x0)
##   unlist(strsplit(x0, "[.]"))[[1]]))
## 
## cc = match(rowData(x1)[,"ENSEMBL"],rowData(x2)[,"X"])
## x11 = x1[!is.na(cc),]
## cc = match(rowData(x2)[,"X"],rowData(x1)[,"ENSEMBL"])
## x22 = x2[!is.na(cc),]
## 
## cc = match(rowData(x11)[,"ENSEMBL"],rowData(x22)[,"X"])
## x3 = cbind(assay(x11[cc,]),assay(x22))
## colnames(x3) = c(colnames_x1,as.character(meta$name_sample))
## 
## se = SummarizedExperiment(assays=x3,
##                           rowData=rownames(x3))
## colData(se) = rbind(colData(x1),colData(x2))
## temp = rep(0,nrow(colData(se)))
## temp[which(colData(se)[,"tissue"] == "case")] = 1
## colData(se) = DataFrame(pair = colData(se)[,"pair"],tissue = temp)
## save(se,file="se.rda")


## ----echo = FALSE,eval=doNot--------------------------------------------------
## pacman::p_load(SummarizedExperiment)
## load("../data/se.rda")
## PRJNA218851 = se[,1:36]
## metadata(PRJNA218851) = list(name = "PRJNA218851")
## colData(PRJNA218851)$pair = colData(PRJNA218851)$pair - 50
## TCGA = se[,37:ncol(se)]
## metadata(TCGA) = list(name = "TCGA")
## save(PRJNA218851,file="../data/PRJNA218851.rda")
## save(TCGA,file="../data/TCGA.rda")


## ----pg1,eval= doBasics-------------------------------------------------------
pacman::p_load(OMICfpp2)
pacman::p_load(SummarizedExperiment,org.Hs.eg.db,
               ggplot2,latex2exp,ReportingTools,GSEABase)


## ----eval=doNot---------------------------------------------------------------
## pacman::p_load(Rsamtools,GenomicFeatures,GenomicAlignments,org.Hs.eg.db)
## gtfFile = "/media/scratch/gencode.v35.chr_patch_hapl_scaff.annotation.gtf"
## txdb = makeTxDbFromGFF(gtfFile, format="gtf")
## genes = exonsBy(txdb, by="gene")
## indir = getwd()
## files = list.files(indir, pattern = '*sort.bam')
## bamLst = BamFileList(files, index=character(),obeyQname=TRUE)
## PRJNA411984 = summarizeOverlaps(features = genes,
##                                 read=bamLst,
##                                 mode="Union",
##                                 singleEnd=FALSE,
##                                 ignore.strand=TRUE,
##                                 fragments=FALSE)
## colnames(PRJNA411984)
## save(PRJNA411984,file="PRJNA411984.rda")


## ----eval=doNot---------------------------------------------------------------
## load("../data/PRJNA411984/PRJNA411984.rda")
## colData(PRJNA411984) = DataFrame(pair = c(1,2,1,2),tissue = c(1,1,0,0))
## metadata(PRJNA411984) = list(name="PRJNA411984")
## rowData(PRJNA411984) = gsub("\\..*","",rownames(assay(PRJNA411984)))
## names(rowData(PRJNA411984)) = "X"
## save(PRJNA411984,file="../data/PRJNA411984.rda")


## ----eval=doNot---------------------------------------------------------------
## gtfFile = "/media/scratch/gencode.v35.chr_patch_hapl_scaff.annotation.gtf"
## txdb = makeTxDbFromGFF(gtfFile, format="gtf")
## genes = exonsBy(txdb, by="gene")
## indir = getwd()
## files = list.files(indir, pattern = '*sort.bam')
## bamLst = BamFileList(files, index=character(),obeyQname=TRUE)
## PRJNA413956 = summarizeOverlaps(features = genes,
##                                 read=bamLst,
##                                 mode="Union",
##                                 singleEnd=FALSE,
##                                 ignore.strand=TRUE,
##                                 fragments=FALSE)
## SampleName = c("SRR6159233","SRR6159234","SRR6191641","SRR6191642",
##                "SRR6191645","RR6191646","SRR6191647","SRR6191648",
##                "SRR6191649","SRR6191650","SRR6191651","SRR6191652",
##                "SRR6191653","SRR6191654")
## tissue = rep(c(1,0),7)
## pair = rep(1:7,each=2)
## colData(PRJNA413956) = DataFrame(SampleName,pair,tissue)
## save(PRJNA413956,file="../data/PRJNA413956.rda")


## ----eval=doNot---------------------------------------------------------------
## pacman::p_load(EnrichmentBrowser,org.Hs.eg.db)
## hsa_go = EnrichmentBrowser::getGenesets("hsa",db="go",onto="BP")
## save(hsa_go,file="hsa_go.rda")


## ----eval=doNot---------------------------------------------------------------
## pacman::p_load(EnrichmentBrowser,org.Hs.eg.db)
## hsa_kegg = getGenesets("hsa",db="kegg")
## save(hsa_kegg,file="hsa_kegg.rda")


## ----eval=doAll---------------------------------------------------------------
## gsc1 = readODS::read_ods("../data/Pathways_cancer.ods")


## ----eval=doAll---------------------------------------------------------------
## load("hsa_kegg.rda")
## kegg.id= na.omit(gsc1$KEGG_ID)
## x1 = unlist(lapply(names(hsa_kegg),function(y) unlist(strsplit(y,"_"))[1]))
## kegg_relevant = hsa_kegg[match(kegg.id,x1)]
## length(kegg_relevant)
## save(kegg_relevant,file="kegg_relevant.rda")


## ----eval=doAll---------------------------------------------------------------
## load("hsa_go.rda")
## go.id = na.omit(gsc1$GO_ID)
## x1 = unlist(lapply(names(hsa_go),function(y) unlist(strsplit(y,"_"))[1]))
## go_relevant = hsa_go[match(go.id,x1)]
## length(go_relevant)
## save(go_relevant,file="go_relevant.rda")


## ----eval=doAll---------------------------------------------------------------
## load("hsa_go.rda")
## go.id.short = na.omit(gsc1$GO_Shortlist)
## x1 = unlist(lapply(names(hsa_go),function(y) unlist(strsplit(y,"_"))[1]))
## go_relevant_short = hsa_go[match(go.id.short,x1)]
## length(go_relevant_short)
## save(go_relevant_short,file="go_relevant_short.rda")


## ----eval=doBasics------------------------------------------------------------
se.gsc = function(se,db = hsa_go,msize=10,name = "go",
                  fractionRemain = .15){
  ## Selecting rows using fractionRemain
  se = se[matrixStats::rowSums2(assay(se)) >=
          ceiling(fractionRemain*ncol(se)),]
  res = AnnotationDbi::select(org.Hs.eg.db, keys=rowData(se)$X,
                              column=c("ENTREZID"), keytype="ENSEMBL")
  b = BiocGenerics::match(rowData(se)$X,res[,"ENSEMBL"])
  gsc = lapply(db,function(y) which(is.element(res[b,"ENTREZID"],y)))
  res2 = sort(unique(unlist(gsc)))
  se2 = se[res2,]
  res2 = res[res2,]
  b2 = BiocGenerics::match(rowData(se2)$X,res2[,"ENSEMBL"])
  gsc2 = lapply(db,function(y) which(is.element(res2[b2,"ENTREZID"],y)))
  gsc2 = gsc2[which(sapply(gsc2,length)>=msize)]
  gsc2 = list(set=gsc2,name=name)
  list(se = se2,gsc = gsc2)
}


## ----eval= doNot--------------------------------------------------------------
## data(PRJNA218851,package="OMICfpp2")
## ##load("../data/PRJNA218851.rda")
## load("hsa_go.rda")
## sg = se.gsc(se=PRJNA218851,db = hsa_go,name = "go")
## 
## pointgene(se=sg$se,
##           tests = list(
##             list(test=proportion.p,name="proportion.p"),
##             list(test=CuzickEdwards,name="CuzickEdwards")),
##           nsim = rep(100,2),
##           type="complete",
##           dir="/home/gag/Nextcloud/pointgene20_Output2/",
##           steps = c(1,0,0,0,0))
## pointgene(se=sg$se,
##           tests = list(
##             list(test=proportion.p,name="proportion.p"),
##             list(test=CuzickEdwards,name="CuzickEdwards")),
##           nsim = rep(100,2),
##           type="between-pair",
##           dir="/home/gag/Nextcloud/pointgene20_Output2/",
##           steps = c(1,0,0,0,0))


## ----eval= doNot--------------------------------------------------------------
## data(TCGA,package="OMICfpp2")
## ##load("../data/TCGA.rda")
## load("hsa_go.rda")
## sg = se.gsc(se=TCGA,db = hsa_go,name = "go")
## pointgene(se=sg$se,
##           tests = list(
##             list(test=proportion.p,name="proportion.p"),
##             list(test=CuzickEdwards,name="CuzickEdwards")),
##           nsim = rep(100,2),
##           type="complete",
##           dir="/home/gag/Nextcloud/pointgene20_Output2/",
##           steps = c(1,0,0,0,0))
## 
## pointgene(se=sg$se,
##           tests = list(
##             list(test=proportion.p,name="proportion.p"),
##             list(test=CuzickEdwards,name="CuzickEdwards")),
##           nsim = rep(100,2),
##           type="between-pair",
##           dir="/home/gag/Nextcloud/pointgene20_Output2/",
##           steps = c(1,0,0,0,0))


## ----eval= doNot--------------------------------------------------------------
## data(PRJNA411984,package="OMICfpp2")
## ##load("../data/PRJNA411984.rda")
## load("hsa_go.rda")
## sg = se.gsc(se=PRJNA411984,db = hsa_go,name = "go")
## 
## pointgene(se=sg$se,
##           tests = list(
##             list(test=proportion.p,name="proportion.p"),
##             list(test=CuzickEdwards,name="CuzickEdwards")),
##           nsim = c(4,100),
##           type="complete",
##           dir="/home/gag/Nextcloud/pointgene20_Output2/",
##           steps = c(1,0,0,0,0))
## 
## pointgene(se=sg$se,
##           tests = list(
##             list(test=proportion.p,name="proportion.p"),
##             list(test=CuzickEdwards,name="CuzickEdwards")),
##           nsim = c(4,100),
##           type="between-pair",
##           dir="/home/gag/Nextcloud/pointgene20_Output2/",
##           steps = c(1,0,0,0,0))


## ----eval= doNot--------------------------------------------------------------
## data(PRJNA413956,package="OMICfpp2")
## ##load("../data/PRJNA413956.rda")
## load("hsa_go.rda")
## sg = se.gsc(se=PRJNA413956,db = hsa_go,name = "go")
## 
## pointgene(se=sg$se,
##           tests = list(
##             list(test=proportion.p,name="proportion.p"),
##             list(test=CuzickEdwards,name="CuzickEdwards")),
##           nsim = c(14,100),
##           type="complete",
##           dir="/home/gag/Nextcloud/pointgene20_Output2/",
##           steps = c(1,0,0,0,0))
## 
## pointgene(se=sg$se,
##           tests = list(
##             list(test=proportion.p,name="proportion.p"),
##             list(test=CuzickEdwards,name="CuzickEdwards")),
##           nsim = c(14,100),
##           type="between-pair",
##           dir="/home/gag/Nextcloud/pointgene20_Output2/",
##           steps = c(1,0,0,0,0))


## ----eval= doNot--------------------------------------------------------------
## data(PRJNA218851,package="OMICfpp2")
## ##load("../data/PRJNA218851.rda")
## load("hsa_go.rda")
## sg = se.gsc(se=PRJNA218851,db = hsa_go,name = "go")
## test2 = list(list(test =CuzickEdwards ,name = "CuzickEdwards"),
##              list(test = DiggleMorrisMorton,name = "DiggleMorrisMorton"),
##              list(test = diggle90,name = "diggle90"))
## 
## for(type in c("complete","between-pair")){
##   cat("type ",type,"\n")
##   for(i in 1:3){
##     cat("test ",test2[[i]]$name,"\n")
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = rep(100,2),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/",
##               steps = c(0,1,1,0,0),
##               gsc = sg$gsc)
##   }
## }


## ----eval= doNot--------------------------------------------------------------
## data(PRJNA218851,package="OMICfpp2")
## ##load("../data/PRJNA218851.rda")
## load("hsa_kegg.rda")
## sg = se.gsc(se=PRJNA218851,db = hsa_kegg,name = "kegg")
## test2 = list(list(test =CuzickEdwards ,name = "CuzickEdwards"),
##              list(test = DiggleMorrisMorton,name = "DiggleMorrisMorton"),
##              list(test = diggle90,name = "diggle90"))
## 
## for(type in c("complete","between-pair")){
##   cat("type ",type,"\n")
##   for(i in 1:3){
##     cat("test ",test2[[i]]$name,"\n")
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = rep(100,2),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/",
##               steps = c(0,1,1,0,0),
##               gsc = sg$gsc)
##   }
## }


## ----eval= doNot--------------------------------------------------------------
## sg = se.gsc(se=TCGA,db = hsa_go,name = "go")
## test2 = list(list(test =CuzickEdwards ,name = "CuzickEdwards"),
##              list(test = DiggleMorrisMorton,name = "DiggleMorrisMorton"),
##              list(test = diggle90,name = "diggle90"))
## 
## for(type in c("complete","between-pair")){
##   for(i in 1:3){
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = rep(100,2),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/",
##               steps = c(0,1,1,0,0),
##               gsc = sg$gsc)
##   }
## }


## ----eval= doNot--------------------------------------------------------------
## sg = se.gsc(se=TCGA,db = hsa_kegg,name = "kegg")
## test2 = list(list(test =CuzickEdwards ,name = "CuzickEdwards"),
##              list(test = DiggleMorrisMorton,name = "DiggleMorrisMorton"),
##              list(test = diggle90,name = "diggle90"))
## 
## for(type in c("complete","between-pair")){
##   for(i in 1:3){
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = rep(100,2),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/",
##               steps = c(0,1,1,0,0),
##               gsc = sg$gsc)
##   }
## }


## ----eval= doNot--------------------------------------------------------------
## data(PRJNA411984,package="OMICfpp2")
## ##load("../data/PRJNA411984.rda")
## sg = se.gsc(se=PRJNA411984,db = hsa_go,name = "go")
## test2 = list(list(test =CuzickEdwards ,name = "CuzickEdwards"),
##              list(test = DiggleMorrisMorton,name = "DiggleMorrisMorton"),
##              list(test = diggle90,name = "diggle90"))
## 
## for(type in c("complete","between-pair")){
##   for(i in 1:3){
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = c(4,100),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/",
##               steps = c(0,1,1,0,0),
##               gsc = sg$gsc)
##   }
## }


## ----eval= doNot--------------------------------------------------------------
## sg = se.gsc(se=PRJNA411984,db = hsa_kegg,name = "kegg")
## test2 = list(list(test =CuzickEdwards ,name = "CuzickEdwards"),
##              list(test = DiggleMorrisMorton,name = "DiggleMorrisMorton"),
##              list(test = diggle90,name = "diggle90"))
## 
## for(type in c("complete","between-pair")){
##   for(i in 1:3){
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = c(4,100),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/",
##               steps = c(0,1,1,0,0),
##               gsc = sg$gsc)
##   }
## }


## ----eval= doNot--------------------------------------------------------------
## data(PRJNA413956,package="OMICfpp2")
## ##load("../data/PRJNA413956.rda")
## load("hsa_go")
## sg = se.gsc(se=PRJNA413956,db = hsa_go,name = "go")
## test2 = list(list(test =CuzickEdwards ,name = "CuzickEdwards"),
##              list(test = DiggleMorrisMorton,name = "DiggleMorrisMorton"),
##              list(test = diggle90,name = "diggle90"))
## 
## for(type in c("complete","between-pair")){
##   for(i in 1:3){
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = c(4,100),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/",
##               steps = c(0,1,1,0,0),
##               gsc = sg$gsc)
##   }
## }


## ----eval= doNot--------------------------------------------------------------
## load("hsa_kegg.rda")
## sg = se.gsc(se=PRJNA413956,db = hsa_kegg,name = "kegg")
## test2 = list(list(test =CuzickEdwards ,name = "CuzickEdwards"),
##              list(test = DiggleMorrisMorton,name = "DiggleMorrisMorton"),
##              list(test = diggle90,name = "diggle90"))
## 
## for(type in c("complete","between-pair")){
##   for(i in 1:3){
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = c(4,100),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/",
##               steps = c(0,1,1,0,0),
##               gsc = sg$gsc)
##   }
## }


## ----eval=doAll---------------------------------------------------------------
## data(PRJNA218851,package="OMICfpp2")
## ##load("../data/PRJNA218851.rda")
## test2 = list(list(test =CuzickEdwards ,name = "CuzickEdwards"),
##              list(test = DiggleMorrisMorton,name = "DiggleMorrisMorton"),
##              list(test = diggle90,name = "diggle90"))
## load("hsa_go.rda")
## sg = se.gsc(se=PRJNA218851,db = hsa_go,name = "go")
## for(type in c("complete","between-pair")){
##   cat("type ",type,"\n")
##   for(i in 1:3){
##     cat("i ",i,"\n")
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = c(100,100),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/PRJNA218851/",
##               steps = c(0,0,0,1,0),
##               gsc = sg$gsc)
##   }
## }
## load("hsa_kegg.rda")
## sg = se.gsc(se=PRJNA218851,db = hsa_kegg,name = "kegg")
## for(type in c("complete","between-pair")){
##   cat("type ",type,"\n")
##   for(i in 1:3){
##     cat("i ",i,"\n")
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = c(100,100),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/PRJNA218851/",
##               steps = c(0,0,0,1,0),
##               gsc = sg$gsc)
##   }
## }


## ----eval=doAll---------------------------------------------------------------
## data(TCGA,package="OMICfpp2")
## ##load("../data/TCGA.rda")
## test2 = list(list(test =CuzickEdwards ,name = "CuzickEdwards"),
##              list(test = DiggleMorrisMorton,name = "DiggleMorrisMorton"),
##              list(test = diggle90,name = "diggle90"))
## load("hsa_go.rda")
## sg = se.gsc(se=TCGA,db = hsa_go,name = "go")
## for(type in c("complete","between-pair")){
##   cat("type ",type,"\n")
##   for(i in 1:3){
##     cat("i ",i,"\n")
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = c(100,100),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/TCGA/",
##               steps = c(0,0,0,1,0),
##               gsc = sg$gsc)
##   }
## }
## load("hsa_kegg.rda")
## sg = se.gsc(se=TCGA,db = hsa_kegg,name = "kegg")
## for(type in c("complete","between-pair")){
##   cat("type ",type,"\n")
##   for(i in 1:3){
##     cat("i ",i,"\n")
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = c(100,100),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/TCGA/",
##               steps = c(0,0,0,1,0),
##               gsc = sg$gsc)
##   }
## }


## ----eval=doAll---------------------------------------------------------------
## data(PRJNA411984,package="OMICfpp2")
## ##load("../data/PRJNA411984.rda")
## test2 = list(list(test =CuzickEdwards ,name = "CuzickEdwards"),
##              list(test = DiggleMorrisMorton,name = "DiggleMorrisMorton"),
##              list(test = diggle90,name = "diggle90"))
## load("hsa_go.rda")
## sg = se.gsc(se=PRJNA411984,db = hsa_go,name = "go")
## for(type in c("complete","between-pair")){
##   cat("type ",type,"\n")
##   for(i in 1:3){
##     cat("i ",i,"\n")
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = c(4,100),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/PRJNA411984/",
##               steps = c(0,0,0,1,0),
##               gsc = sg$gsc)
##   }
## }
## load("hsa_kegg.rda")
## sg = se.gsc(se=PRJNA411984,db = hsa_kegg,name = "kegg")
## for(type in c("complete","between-pair")){
##   cat("type ",type,"\n")
##   for(i in 1:3){
##     cat("i ",i,"\n")
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = c(4,100),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/PRJNA411984/",
##               steps = c(0,0,0,1,0),
##               gsc = sg$gsc)
##   }
## }


## ----eval=doAll---------------------------------------------------------------
## data(PRJNA413956,package="OMICfpp2")
## ##load("../data/PRJNA413956.rda")
## test2 = list(list(test =CuzickEdwards ,name = "CuzickEdwards"),
##              list(test = DiggleMorrisMorton,name = "DiggleMorrisMorton"),
##              list(test = diggle90,name = "diggle90"))
## load("hsa_go.rda")
## sg = se.gsc(se=PRJNA413956,db = hsa_go,name = "go")
## for(type in c("complete","between-pair")){
##   cat("type ",type,"\n")
##   for(i in 1:3){
##     cat("i ",i,"\n")
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = c(4,100),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/PRJNA413956/",
##               steps = c(0,0,0,1,0),
##               gsc = sg$gsc)
##   }
## }
## load("hsa_kegg.rda")
## sg = se.gsc(se=PRJNA413956,db = hsa_kegg,name = "kegg")
## for(type in c("complete","between-pair")){
##   cat("type ",type,"\n")
##   for(i in 1:3){
##     cat("i ",i,"\n")
##     pointgene(se=sg$se,
##               tests = list(
##                 list(test=proportion.p,name="proportion.p"),
##                 list(test=test2[[i]]$test,name=test2[[i]]$name)),
##               nsim = c(4,100),
##               type=type,
##               dir="/home/gag/Nextcloud/pointgene20_Output2/PRJNA413956/",
##               steps = c(0,0,0,1,0),
##               gsc = sg$gsc)
##   }
## }


## ----eval=doBasics------------------------------------------------------------
data(PRJNA218851,package="OMICfpp2")
data(PRJNA411984,package="OMICfpp2")
data(PRJNA413956,package="OMICfpp2")
data(TCGA,package="OMICfpp2")

sens = list(
  list(data = PRJNA218851,name= "PRJNA218851"),
  list(data = PRJNA411984,name= "PRJNA411984"),
  list(data = PRJNA413956,name= "PRJNA413956"),
  list(data = TCGA,name= "TCGA"))

testRLs = list(
  list(testRL = CuzickEdwards,testRLn = "CuzickEdwards"),
  list(testRL = DiggleMorrisMorton,testRLn = "DiggleMorrisMorton"),
  list(testRL = diggle90,testRLn = "diggle90"))

types = c("between-pair","complete")


## ----eval=doAll---------------------------------------------------------------
## load("hsa_kegg.rda")
## p.kegg = matrix(NA,nrow=length(hsa_kegg),ncol=24)
## rownames(p.kegg) = names(hsa_kegg)
## names0 = NULL
## col0 = 0
## for(i in 1:4){
##   sg = se.gsc(se=sens[[i]]$data,db = hsa_kegg,name = "kegg")
##   for(j in 1:length(testRLs)){
##     for(k in 1:2){
##       col0 = col0 +1
##       tests0 = list(list(test=proportion.p,name="proportion.p"),
##                     list(test=testRLs[[j]]$testRL,
##                          name=testRLs[[j]]$testRLn))
##       dir0 = paste0("/home/gag/Nextcloud/pointgene20_Output2/",
##                     sens[[i]]$name,"/")
##       p.value = pointgene(se = sg$se,
##                           tests = tests0,
##                           nsim = rep(100,2),type=types[k],
##                           dir=dir0,
##                           steps = c(0,0,0,1,1),gsc=sg$gsc,aggr=mean)
##       aa = match(rownames(p.value),rownames(p.kegg))
##       p.kegg[aa,col0] = p.value
##       names0 = c(names0,paste(sens[[i]]$name,types[k],
##                               testRLs[[j]]$testRLn,sep="_"))
##     }
##   }
## }
## p.kegg = data.frame(p.kegg)
## names(p.kegg) = names0
## save(p.kegg,file="p.kegg.rda")


## ----eval=doAll---------------------------------------------------------------
## select_one = function(x,to_select=1,na.rm=TRUE){
##   if(na.rm) x = na.omit(x)
##   x[to_select]
## }


## ----eval=doAll---------------------------------------------------------------
## load("hsa_kegg.rda")
## p.kegg_one = matrix(NA,nrow=length(hsa_kegg),ncol=24)
## rownames(p.kegg_one) = names(hsa_kegg)
## names0 = NULL
## col0 = 0
## for(i in 1:4){
##   sg = se.gsc(se=sens[[i]]$data,db = hsa_kegg,name = "kegg")
##   for(j in 1:length(testRLs)){
##     for(k in 1:2){
##       col0 = col0 +1
##       tests0 = list(list(test=proportion.p,name="proportion.p"),
##                     list(test=testRLs[[j]]$testRL,
##                          name=testRLs[[j]]$testRLn))
##       dir0 = paste0("/home/gag/Nextcloud/pointgene20_Output2/",
##                     sens[[i]]$name,"/")
##       p.value = pointgene(se = sg$se,
##                           tests = tests0,
##                           nsim = rep(100,2),type=types[k],
##                           dir=dir0,
##                           steps = c(0,0,0,1,1),gsc=sg$gsc,aggr=select_one)
##       aa = match(rownames(p.value),rownames(p.kegg_one))
##       p.kegg_one[aa,col0] = p.value
##       names0 = c(names0,paste(sens[[i]]$name,types[k],
##                               testRLs[[j]]$testRLn,sep="_"))
##     }
##   }
## }
## p.kegg_one = data.frame(p.kegg_one)
## names(p.kegg_one) = names0
## save(p.kegg_one,file="p.kegg_one.rda")


## ----eval=doAll---------------------------------------------------------------
## load("hsa_go.rda")
## p.go = matrix(NA,nrow=length(hsa_go),ncol=24)
## rownames(p.go) = names(hsa_go)
## names0 = NULL
## col0 = 0
## for(i in 1:4){
##   sg = se.gsc(se=sens[[i]]$data,db = hsa_go,name = "go")
##   for(j in 1:length(testRLs)){
##     for(k in 1:2){
##       col0 = col0 +1
##       tests0 = list(list(test=proportion.p,name="proportion.p"),
##                     list(test=testRLs[[j]]$testRL,
##                          name=testRLs[[j]]$testRLn))
##       dir0 = paste0("/home/gag/Nextcloud/pointgene20_Output2/",
##                     sens[[i]]$name,"/")
##       p.value = pointgene(se = sg$se,
##                           tests = tests0,
##                           nsim = rep(100,2),type=types[k],
##                           dir=dir0,
##                           steps = c(0,0,0,1,1),gsc=sg$gsc,aggr=mean)
##       aa = match(rownames(p.value),rownames(p.go))
##       p.go[aa,col0] = p.value
##       names0 = c(names0,paste(sens[[i]]$name,types[k],
##                               testRLs[[j]]$testRLn,sep="_"))
##     }
##   }
## }
## 
## p.go = data.frame(p.go)
## names(p.go) = names0
## save(p.go,file="p.go.rda")


## ----eval=doAll---------------------------------------------------------------
## load("hsa_go.rda")
## p.go_one = matrix(NA,nrow=length(hsa_go),ncol=24)
## rownames(p.go_one) = names(hsa_go)
## names0 = NULL
## col0 = 0
## for(i in 1:4){
##   sg = se.gsc(se=sens[[i]]$data,db = hsa_go,name = "go")
##   for(j in 1:length(testRLs)){
##     for(k in 1:2){
##       col0 = col0 +1
##       tests0 = list(list(test=proportion.p,name="proportion.p"),
##                     list(test=testRLs[[j]]$testRL,
##                          name=testRLs[[j]]$testRLn))
##       dir0 = paste0("/home/gag/Nextcloud/pointgene20_Output2/",
##                     sens[[i]]$name,"/")
##       p.value = pointgene(se = sg$se,
##                           tests = tests0,
##                           nsim = rep(100,2),type=types[k],
##                           dir=dir0,
##                           steps = c(0,0,0,1,1),gsc=sg$gsc,aggr=mean)
##       aa = match(rownames(p.value),rownames(p.go_one))
##       p.go_one[aa,col0] = p.value
##       names0 = c(names0,paste(sens[[i]]$name,types[k],
##                               testRLs[[j]]$testRLn,sep="_"))
##     }
##   }
## }
## 
## p.go_one = data.frame(p.go_one)
## names(p.go_one) = names0
## save(p.go_one,file="p.go_one.rda")


## ----eval=doAll---------------------------------------------------------------
## load("p.go.rda")
## load("go_relevant.rda")
## toremove = which(apply(p.go,1,function(x) all(is.na(x))))
## p_go = p.go[-toremove,]
## save(p_go,file="p_go.rda") ## p.go without NAs
## relevant = match(names(go_relevant),rownames(p_go))
## relevant = na.omit(relevant)
## p_go_relevant = p_go[relevant,]
## save(p_go_relevant,file="p_go_relevant.rda")
## df_go = data.frame(rownames(p_go_relevant),apply(p_go_relevant,1,min,
##                                                  na.rm=TRUE))
## save(df_go,file="df_go.rda")

## ----eval=doAll---------------------------------------------------------------
## load("p.go_one.rda")
## load("go_relevant.rda")
## toremove = which(apply(p.go_one,1,function(x) all(is.na(x))))
## p_go_one = p.go_one[-toremove,]
## save(p_go_one,file="p_go_one.rda") ## p.go_one without NAs
## relevant = match(names(go_relevant),rownames(p_go_one))
## relevant = na.omit(relevant)
## p_go_one_relevant = p_go_one[relevant,]
## save(p_go_one_relevant,file="p_go_one_relevant.rda")
## df_go_one = data.frame(rownames(p_go_one_relevant),
##                        apply(p_go_one_relevant,1,min,na.rm=TRUE))
## save(df_go_one,file="df_go_one.rda")


## ----eval=doAll---------------------------------------------------------------
## load("p.kegg.rda")
## load("kegg_relevant.rda")
## toremove = which(apply(p.kegg,1,function(x) all(is.na(x))))
## p_kegg = p.kegg[-toremove,]
## save(p_kegg,file="p_kegg.rda") ## p.kegg without NAs
## relevant = match(names(kegg_relevant),rownames(p_kegg))
## relevant = na.omit(relevant)
## p_kegg_relevant = p_kegg[relevant,]
## save(p_kegg_relevant,file="p_kegg_relevant.rda")
## df_kegg = data.frame(rownames(p_kegg_relevant),apply(p_kegg_relevant,1,min,
##                                                      na.rm=TRUE))
## save(df_kegg,file="df_kegg.rda")
## View(df_kegg)


## ----eval=doAll---------------------------------------------------------------
## load("p.kegg_one.rda")
## load("kegg_relevant.rda")
## toremove = which(apply(p.kegg_one,1,function(x) all(is.na(x))))
## p_kegg_one = p.kegg_one[-toremove,]
## save(p_kegg_one,file="p_kegg_one.rda") ## p.kegg_one without NAs
## relevant = match(names(kegg_relevant),rownames(p_kegg_one))
## relevant = na.omit(relevant)
## p_kegg_one_relevant = p_kegg_one[relevant,]
## save(p_kegg_one_relevant,file="p_kegg_one_relevant.rda")
## df_kegg_one = data.frame(rownames(p_kegg_one_relevant),
##                          apply(p_kegg_one_relevant,1,min,na.rm=TRUE))
## save(df_kegg_one,file="df_kegg_one.rda")
## View(df_kegg_one)


## ----eval=doAll---------------------------------------------------------------
## load("p_go.rda")
## id = unlist(lapply(rownames(p_go),function(y) unlist(strsplit(y,"_"))[1]))
## GO = ifelse(id == "NA", NA,
##             paste("<a href='http://amigo.geneontology.org/amigo/term/",
##                   id, "'>", id, "</a>", sep = ""))
## df = data.frame(GO,p_go)
## htmlRep = HTMLReport(shortName = "p_go",
##                      reportDirectory = "./reports")
## publish(df, htmlRep)
## finish(htmlRep)

## ----eval=doAll---------------------------------------------------------------
## load("p_go_relevant.rda")
## id = unlist(lapply(rownames(p_go_relevant),function(y)
##   unlist(strsplit(y,"_"))[1]))
## GO = ifelse(id == "NA", NA,
##             paste("<a href='http://amigo.geneontology.org/amigo/term/",
##                   id, "'>", id, "</a>", sep = ""))
## df = data.frame(GO,p_go_relevant)
## htmlRep = HTMLReport(shortName = "p_go_relevant",
##                      reportDirectory = "./reports")
## publish(df, htmlRep)
## finish(htmlRep)

## ----eval=doAll---------------------------------------------------------------
## load("p_go_one_relevant.rda")
## id = unlist(lapply(rownames(p_go_one_relevant),function(y)
##   unlist(strsplit(y,"_"))[1]))
## GO = ifelse(id == "NA", NA,
##             paste("<a href='http://amigo.geneontology.org/amigo/term/",
##                   id, "'>", id, "</a>", sep = ""))
## df = data.frame(GO,p_go_one_relevant)
## htmlRep = HTMLReport(shortName = "p_go_one_relevant",
##                      reportDirectory = "./reports")
## publish(df, htmlRep)
## finish(htmlRep)


## ----eval=doAll---------------------------------------------------------------
## load("p_kegg.rda")
## id = unlist(lapply(rownames(p_kegg),function(y) unlist(strsplit(y,"_"))[1]))
## KEGG = ifelse(id == "NA", NA,
##               paste("<a href='http://www.genome.jp/dbget-bin/www_bget?",
##                     id, "'>", id, "</a>", sep = ""))
## 
## df = data.frame(KEGG,p_kegg)
## htmlRep = HTMLReport(shortName = "p_kegg",
##                      reportDirectory = "./reports")
## publish(df, htmlRep)
## finish(htmlRep)

## ----eval=doAll---------------------------------------------------------------
## load("p_kegg_relevant.rda")
## id = unlist(lapply(rownames(p_kegg_relevant),function(y)
##   unlist(strsplit(y,"_"))[1]))
## KEGG = ifelse(id == "NA", NA,
##               paste("<a href='http://www.genome.jp/dbget-bin/www_bget?",
##                     id, "'>", id, "</a>", sep = ""))
## 
## df = data.frame(KEGG,p_kegg_relevant)
## htmlRep = HTMLReport(shortName = "p_kegg_relevant",
##                      reportDirectory = "./reports")
## publish(df, htmlRep)
## finish(htmlRep)


## ----eval=doAll---------------------------------------------------------------
## load("p_kegg_one.rda")
## id = unlist(lapply(rownames(p_kegg_one),function(y) unlist(strsplit(y,"_"))[1]))
## KEGG = ifelse(id == "NA", NA,
##               paste("<a href='http://www.genome.jp/dbget-bin/www_bget?",
##                     id, "'>", id, "</a>", sep = ""))
## 
## df = data.frame(KEGG,p_kegg_one)
## htmlRep = HTMLReport(shortName = "p_kegg_one",
##                      reportDirectory = "./reports")
## publish(df, htmlRep)
## finish(htmlRep)


## ----eval=doAll---------------------------------------------------------------
## load("p_kegg_one_relevant.rda")
## id = unlist(lapply(rownames(p_kegg_one_relevant),function(y)
##   unlist(strsplit(y,"_"))[1]))
## KEGG = ifelse(id == "NA", NA,
##               paste("<a href='http://www.genome.jp/dbget-bin/www_bget?",
##                     id, "'>", id, "</a>", sep = ""))
## 
## df = data.frame(KEGG,p_kegg_one_relevant)
## htmlRep = HTMLReport(shortName = "p_kegg_one_relevant",
##                      reportDirectory = "./reports")
## publish(df, htmlRep)
## finish(htmlRep)


## ----eval=doNot---------------------------------------------------------------
## ################################################################################################
## 
## library(Rsamtools)
## library(GenomicFeatures)
## library(GenomicAlignments)
## library(org.Hs.eg.db)
## library(edgeR)
## library(VennDiagram)
## library(goseq)
## 
## ###############################################################################################
## # R code used for edgeR-GOseq pipeline (example with the PRJNA411984 dataset)
## ##############################################################################################
## 
## gtfFile = "/media/scratch/gencode.v35.chr_patch_hapl_scaff.annotation.gtf"
## txdb = makeTxDbFromGFF(gtfFile, format="gtf")
## genes = exonsBy(txdb, by="gene")
## indir = getwd()
## files = list.files(indir, pattern = '*sort.bam')
## bamLst = BamFileList(files, index=character(),obeyQname=TRUE)
## PRJNA411984 = summarizeOverlaps(features = genes,
##                                 read=bamLst,
##                                 mode="Union",
##                                 singleEnd=FALSE,
##                                 ignore.strand=TRUE,
##                                 fragments=FALSE)
## colnames(PRJNA411984)
## # save(PRJNA411984,file="PRJNA411984.rda")
## 
## load("PRJNA411984.rda")
## colnames(PRJNA411984)
## # [1] "SRR6067723_sort.bam" "SRR6067725_sort.bam" "SRR6067729_sort.bam" "SRR6067731_sort.bam"
## SampleName = c("SRR6067723","SRR6067725","SRR6067729","SRR6067731")
## tissue = c("cancer","cancer","normal","normal")
## replication = c("1", "2", "1", "2")
## colData(PRJNA411984) = DataFrame(SampleName, tissue, replication)
## PRJNA411984_met = PRJNA411984
## # save(PRJNA411984_met,file="PRJNA411984_met.rda")
## 
## 
## ## Convert to edgeR format:
## edgeRmatrix_STAR = assay(PRJNA411984)
## groups = factor(tissue,
##                 levels=c("cancer","normal"))
## STAR_DATA_y = DGEList(counts=edgeRmatrix_STAR,group=groups)
## dim(STAR_DATA_y)
## 
## ##############################################
## ####### Filtering and normalization
## 
## keep <- filterByExpr(STAR_DATA_y)
## summary(keep)
## #   Mode   FALSE    TRUE
## # logical   46841   20212
## 
## STAR_DATA_y_filt = STAR_DATA_y[keep, , keep.lib.sizes=FALSE]
## dim(STAR_DATA_y_filt)
## 
## ## annotation:
## tmp = gsub("\\..*","",row.names(STAR_DATA_y_filt))
## row.names(STAR_DATA_y_filt) = tmp
## STAR_Data = STAR_DATA_y_filt
## preIDSymbol = AnnotationDbi::select(org.Hs.eg.db,
##                                     keys=as.character(rownames(STAR_Data)),
##                                     column=c("SYMBOL", "ENTREZID"),
##                                     keytype="ENSEMBL")
## STAR_Data$genes$ENSEMBL = rownames(STAR_Data)
## m = match(STAR_Data$genes$ENSEMBL, preIDSymbol$ENSEMBL)
## STAR_Data$genes$SYMBOL = preIDSymbol$SYMBOL[m]
## STAR_Data$genes$ENTREZID = preIDSymbol$ENTREZID[m]
## STAR_DATA_f = STAR_Data
## STAR_DATA_f$genes = as.matrix(DataFrame(STAR_Data$genes$ENSEMBL,
##                                         STAR_Data$genes$SYMBOL,
##                                         STAR_Data$genes$ENTREZID))
## colnames(STAR_DATA_f$genes) = c("ENSEMBL","SYMBOL", "ENTREZID")
## head(STAR_DATA_f$genes)
## dim(STAR_DATA_f)
## 
## # Remove genes that have duplicate symbol:
## d = duplicated(STAR_DATA_f$genes[,2])
## summary(d)
## # Mode   FALSE    TRUE
## #logical   14769    5443
## 
## #duplicates are removed and lib size is recalculated:
## STAR_DATA_f = STAR_DATA_f[!d, , keep.lib.sizes=FALSE]
## dim(STAR_DATA_f)
## 
## # The most used method (recommended) to normalize is:
## PRJNA411984_norm_filt_annot = calcNormFactors(STAR_DATA_f)
## 
## # save(PRJNA411984_norm_filt_annot,file="PRJNA411984_norm_filt_annot.rda")
## 
## load("PRJNA411984_norm_filt_annot.rda")
## 
## 
## #########################################################
## load("PRJNA413956_norm_filt_annot.rda")
## View(PRJNA413956_norm_filt_annot)
## summarized = PRJNA413956_norm_filt_annot
## #########################################################
## 
## disp=estimateCommonDisp(summarized)
## disp$common.dispersion
## tested=exactTest(disp)
## topTags(tested)
## 
## genes=as.integer(p.adjust(tested$table$PValue[tested$table$logFC!=0],
## 		method="BH")<.05)
## names(genes)=row.names(tested$table[tested$table$logFC!=0,])
## table(genes)
## 
## View(supportedOrganisms())
## # hg38 --> hg19
## 
## supportedOrganisms()[supportedOrganisms()$Genome=="hg19",]
## pwf=nullp(genes,"hg19","ensGene")
## head(pwf)
## GO.wall=goseq(pwf,"hg19","ensGene")
## head(GO.wall)
## 
## GO.samp=goseq(pwf,"hg19","ensGene",method="Sampling",repcnt=1000, test.cats=c("GO:BP"))
## head(GO.samp)
## 
## write.csv(GO.samp, file = "GO_PRJNA413956.csv")
## 
## ###################################################
## ### KEGG_goseq
## ###################################################
## pwf=nullp(genes,'hg19','ensGene')
## KEGG=goseq(pwf,'hg19','ensGene',test.cats="KEGG")
## head(KEGG)
## 
## write.csv(KEGG, file = "KEGG_PRJNA413956.csv")
## 
## 
## 
## #####################################################
## load("PRJNA411984_norm_filt_annot.rda")
## View(PRJNA411984_norm_filt_annot)
## summarized = PRJNA411984_norm_filt_annot
## #####################################################
## 
## disp=estimateCommonDisp(summarized)
## disp$common.dispersion
## tested=exactTest(disp)
## topTags(tested)
## 
## genes=as.integer(p.adjust(tested$table$PValue[tested$table$logFC!=0],
##                           method="BH")<.05)
## names(genes)=row.names(tested$table[tested$table$logFC!=0,])
## table(genes)
## 
## supportedOrganisms()[supportedOrganisms()$Genome=="hg19",]
## pwf=nullp(genes,"hg19","ensGene")
## head(pwf)
## GO.wall=goseq(pwf,"hg19","ensGene")
## head(GO.wall)
## 
## GO.samp=goseq(pwf,"hg19","ensGene",method="Sampling",repcnt=1000, test.cats=c("GO:BP"))
## head(GO.samp)
## 
## write.csv(GO.samp, file = "GO_PRJNA411984.csv")
## 
## ###################################################
## ### KEGG_goseq
## ###################################################
## pwf=nullp(genes,'hg19','ensGene')
## KEGG=goseq(pwf,'hg19','ensGene',test.cats="KEGG")
## head(KEGG)
## 
## write.csv(KEGG, file = "KEGG_PRJNA411984.csv")
## 
## 
## #####################################################
## load("PRJNA218851_norm_filt_annot.rda")
## View(PRJNA218851_norm_filt_annot)
## summarized = PRJNA218851_norm_filt_annot
## #####################################################
## 
## disp=estimateCommonDisp(summarized)
## disp$common.dispersion
## tested=exactTest(disp)
## topTags(tested)
## 
## genes=as.integer(p.adjust(tested$table$PValue[tested$table$logFC!=0],
##                           method="BH")<.05)
## names(genes)=row.names(tested$table[tested$table$logFC!=0,])
## table(genes)
## 
## supportedOrganisms()[supportedOrganisms()$Genome=="hg19",]
## pwf=nullp(genes,"hg19","ensGene")
## head(pwf)
## GO.wall=goseq(pwf,"hg19","ensGene")
## head(GO.wall)
## 
## GO.samp=goseq(pwf,"hg19","ensGene",method="Sampling",repcnt=1000, test.cats=c("GO:BP"))
## head(GO.samp)
## 
## write.csv(GO.samp, file = "GO_PRJNA218851.csv")
## 
## ###################################################
## ### KEGG_goseq
## ###################################################
## pwf=nullp(genes,'hg19','ensGene')
## KEGG=goseq(pwf,'hg19','ensGene',test.cats="KEGG")
## head(KEGG)
## 
## write.csv(KEGG, file = "KEGG_PRJNA218851.csv")
## 
## #####################################################
## load("TCGA_norm_filt_annot.rda")
## View(TCGA_norm_filt_annot)
## summarized = TCGA_norm_filt_annot
## #####################################################
## 
## disp=estimateCommonDisp(summarized)
## disp$common.dispersion
## tested=exactTest(disp)
## topTags(tested)
## 
## genes=as.integer(p.adjust(tested$table$PValue[tested$table$logFC!=0],
##                           method="BH")<.05)
## names(genes)=row.names(tested$table[tested$table$logFC!=0,])
## table(genes)
## 
## View(supportedOrganisms())
## # hg38 --> hg19
## 
## supportedOrganisms()[supportedOrganisms()$Genome=="hg19",]
## pwf=nullp(genes,"hg19","ensGene")
## head(pwf)
## GO.wall=goseq(pwf,"hg19","ensGene")
## head(GO.wall)
## 
## GO.samp=goseq(pwf,"hg19","ensGene",method="Sampling",repcnt=1000, test.cats=c("GO:BP"))
## head(GO.samp)
## 
## write.csv(GO.samp, file = "GO_TCGA.csv")
## 
## ###################################################
## ### KEGG_goseq
## ###################################################
## pwf=nullp(genes,'hg19','ensGene')
## KEGG=goseq(pwf,'hg19','ensGene',test.cats="KEGG")
## head(KEGG)
## 
## write.csv(KEGG, file = "KEGG_TCGA.csv")


## ----eval=doNot---------------------------------------------------------------
## setwd("~/Nextcloud/pointgene17/SupplementaryMaterial/")
## library(OMICfpp2)
## n0 = 20
## N0 = 1000
## ngs = 20
## ngsc = 50
## gsc0 = vector("list",ngsc)
## row = rep(1:ngsc,each=ngs)
## for(i in 1:ngsc)
##   gsc0[[i]] = which(row == i)
## 
## m0 = 30
## deltas = seq(1,40,2)
## size = 150
## 
## tests = c("CuzickEdwards","DiggleMorrisMorton","diggle90")
## types = c("between-pair","complete")
## 
## for(testLabelling in tests){
##     for(type in types){
##         result = NULL
##         for(delta in deltas){
##             mu0 = c(30,rep(30+delta,50))
##             param0 = cbind(mu0,rep(size,51))
##             x0 = rPairedNB2(n=n0,N=N0,param = param0,gsc = gsc0)
##             y0 = cbind(rep(1:n0,each=2),rep(0:1,n0))
##             pp = ppgene(x=x0,y=y0,testPair=proportion.p,nsim = 1,type,
##                         gsc = gsc0,testLabelling,
##                         nmax=1000,file.labelling = NULL)
##             result = rbind(result,c(delta,mean(1-unlist(pp[[2]]))))
##         }
##         save(result,file=paste0("results/SimulationStudy_NB_30_",
##                                 testLabelling,"_",type,".rda"))
##     }
## }
## 


## ----eval=doNot---------------------------------------------------------------
## deltas = seq(1,40,2)
## tests = c("CuzickEdwards","DiggleMorrisMorton","diggle90")
## types = c("between-pair","complete")
## nrow.df = length(deltas)*length(tests)*length(types)
## df = data.frame(matrix(NA,nrow = nrow.df,ncol = 4))
## names(df) = c("test","type","delta","p.value")
## 
## df = NULL
## for(i in  1:length(tests)){
##     for(j in 1:length(types)){
##         load(paste0("results/SimulationStudy_NB_30_",tests[i],"_",
##                     types[j],".rda"))
##         r0 = result
##       df =  rbind(df,cbind(rep(i,length(deltas)),rep(j,length(deltas)),r0))
## 
##     }
## }
## df = data.frame(df)
## names(df) = c("test","type","delta","p.value")
## df$test = factor(df$test,levels=1:3,
##                  labels=c("CuzickEdwards","DiggleMorrisMorton","diggle90"))
## df$type = factor(df$type,levels=1:2,labels=c("between-pair","complete"))
## 
## p = ggplot(df,aes(x=delta,y=p.value)) + geom_point()
## p = p + facet_grid(type ~ test)
## ggsave(p,file = "results/SimulationStudyNB1.png")


## ----eval=doNot---------------------------------------------------------------
## library(OMICfpp2)
## n0 = 20
## N0 = 1000
## ngs = 20
## ngsc = 50
## gsc0 = vector("list",ngsc)
## row = rep(1:ngsc,each=ngs)
## for(i in 1:ngsc)
##   gsc0[[i]] = which(row == i)
## 
## lambdas = seq(1,40,2)
## 
## tests = c("CuzickEdwards","DiggleMorrisMorton","diggle90")
## types = c("between-pair","complete")
## 
## for(testLabelling in tests){
##     for(type in types){
##         result =NULL
##         for(lambda in lambdas){
##             lambda0 = c(20,rep(lambda,ngsc))
##             x0 = rPairedPoisson2(n=n0,N=N0,lambda=lambda0,gsc=gsc0)
##             y0 = cbind(rep(1:n0,each=2),rep(0:1,n0))
##             pp = ppgene(x=x0,y=y0,testPair=proportion.p,nsim = 1,type,
##                         gsc = gsc0,testLabelling,
##                         nmax=1000,file.labelling = NULL)
##             result = rbind(result,c(lambda,mean(1-unlist(pp[[2]]))))
##         }
##         save(result,file=paste0("results/SimulationStudy_Poisson_30_",
##                                 testLabelling,"_",type,".rda"))
##     }
## }
## 

## ----eval=doNot---------------------------------------------------------------
## lambdas = seq(1,40,2)
## tests = c("CuzickEdwards","DiggleMorrisMorton","diggle90")
## types = c("between-pair","complete")
## nrow.df = length(lambdas)*length(tests)*length(types)
## df = data.frame(matrix(NA,nrow = nrow.df,ncol = 4))
## names(df) = c("test","type","delta","p.value")
## 
## df = NULL
## for(i in  1:length(tests)){
##     for(j in 1:length(types)){
##         load(paste0("results/SimulationStudy_Poisson_30_",tests[i],"_",
##                     types[j],".rda"))
##         r0 = result
##       df =  rbind(df,cbind(rep(i,length(lambdas)),rep(j,length(lambdas)),r0))
## 
##     }
## }
## df = data.frame(df)
## names(df) = c("test","type","delta","p.value")
## df$test = factor(df$test,levels=1:3,
##                  labels=c("CuzickEdwards","DiggleMorrisMorton","diggle90"))
## df$type = factor(df$type,levels=1:2,labels=c("between-pair","complete"))
## 
## p = ggplot(df,aes(x=delta,y=p.value)) + geom_point()
## p = p + facet_grid(type ~ test)
## 
## ggsave(p,file = "results/SimulationStudyPoisson1.png")

